![Logo](https://github.com/XanaduAI/MrMustard/blob/main/mm_white.png#gh-light-mode-only)
![Logo](https://github.com/XanaduAI/MrMustard/blob/main/mm_dark.png#gh-dark-mode-only)

[![Apache-2.0](https://img.shields.io/badge/License-Apache--2.0-blue)](https://opensource.org/licenses/Apache-2.0)
[![Actions Status](https://github.com/XanaduAI/MrMustard/workflows/Tests/badge.svg)](https://github.com/XanaduAI/MrMustard/actions)
[![Python version](https://img.shields.io/pypi/pyversions/mrmustard.svg?style=popout-square)](https://pypi.org/project/MrMustard/)

Mr Mustard is a differentiable simulator with a sophisticated built-in optimizer, that operates seamlessly across phase space and Fock space. It is built on top of an agnostic autodiff interface, to allow for plug-and-play backends (`numpy` by default).

Mr Mustard supports:
- Phase space representation of Gaussian states and Gaussian channels on an arbitrary number of modes
- Exact Fock representation of any Gaussian circuit and any Gaussian state up to an arbitrary cutoff
- Riemannian optimization on the symplectic group (for Gaussian transformations) and on the unitary group (for interferometers)
- Adam optimizer for euclidean parameters
- Single-mode gates (parallelizable):
    - squeezing, displacement, phase rotation, attenuator, amplifier, additive noise, phase noise
- Two-mode gates:
    - beam splitter, Mach-Zehnder interferometer, two-mode squeezing, CX, CZ, CPHASE
- N-mode gates (with dedicated Riemannian optimization):
    - Interferometer (unitary), RealInterferometer (orthogonal), Gaussian transformation (symplectic)
- Single-mode states (parallelizable):
    - Vacuum, Coherent, SqueezedVacuum, Thermal, Fock
- Two-mode states:
    - TMSV (two-mode squeezed vacuum)
- N-mode states:
    - Gaussian
- Photon number moments and entropic measures
- PNR detectors and Threshold detectors with trainable quantum efficiency and dark counts
- Homodyne, Heterodyne and Generaldyne measurements
- Composable circuits
- Plug-and-play backends (`numpy` as default)
- An abstraction layer `XPTensor` for seamless symplectic algebra (experimental)

# Increased numerical stability using Julia [optional]

Converting phase space objects to Fock space can be numerically unstable due to accumulating floating point errors.
To resolve this, the conversion can be performed with extended-precision arithmetic. To use this feature,
an installation of [Julia](https://github.com/JuliaLang/juliaup#installation) is required (version 1.9.3 recommended).

* When installing MrMustard via devcontainer, Julia and its required packages are automatically installed.

* When installing MrMustard via `poetry install` or `pip install`, the required Julia packages have to be installed manually as follows:

```
julia --project="julia_pkg" -e "using Pkg; Pkg.instantiate()"
```

* When installing MrMustard via the `MakeFile`, the required Julia packages are automatically installed _only_ if Julia was previously installed by the user.

# The lab module
The lab module contains things you'd find in a lab: states, transformations, measurements, circuits. States can be used at the beginning of a circuit as well as at the end, in which case a state is interpreted as a measurement (a projection onto that state). Transformations are usually parametrized and map states to states. The action on states is differentiable with respect to the state and to the gate parameters.


## 1. States and Gates
Here are a few examples of states and gates:
```python
import numpy as np
from mrmustard.lab import *

vac = Vacuum(num_modes=2)        # 2-mode vacuum state
coh = Coherent(x=0.1, y=-0.4)    # coh state |alpha> with alpha = 0.1 - 0.4j
sq  = SqueezedVacuum(r=0.5)      # squeezed vacuum state
g   = Gaussian(num_modes=2)      # 2-mode Gaussian state with zero means
fock4 = Fock(4)                  # fock state |4>

D  = Dgate(x=1.0, y=-0.4)         # Displacement by 1.0 along x and -0.4 along y
S  = Sgate(r=0.5)                 # Squeezer with r=0.5
R  = Rgate(angle=0.3)             # Phase rotation by 0.3
A  = Amplifier(gain=2.0)          # noisy amplifier with 200% gain
L  = Attenuator(0.5)              # pure loss channel with 50% transmissivity
N  = AdditiveNoise(noise=0.1)     # additive noise with noise level 0.1

BS = BSgate(theta=np.pi/4)          # 50/50 beam splitter
S2 = S2gate(r=0.5)                  # two-mode squeezer
MZ = MZgate(phi_a=0.3, phi_b=0.1)   # Mach-Zehnder interferometer
I  = Interferometer(8)              # 8-mode interferometer
L  = Attenuator(0.5)                # pure lossy channel with 50% transmissivity
A  = Amplifier(gain=2.0, nbar=1.0)  # noisy amplifier with 200% gain
```

The `repr` of single-mode states shows the Wigner function:
<img width="571" alt="Screen Shot 2021-12-06 at 1 31 17 PM" src="https://user-images.githubusercontent.com/8944955/144902008-8d26d59c-8600-4391-9144-ffcc1b2215c2.png">

```python
cat_amps = Coherent(2.0).ket([20]) + Coherent(-2.0).ket([20])
cat_amps = cat_amps / np.linalg.norm(cat_amps)
cat = State(ket=cat_amps)
cat
```
<img width="538" alt="Screen Shot 2021-12-06 at 8 27 06 PM" src="https://user-images.githubusercontent.com/8944955/144949009-ebf7bbf8-9240-406c-ab99-bf8c36acd3f7.png">

States (even those in Fock representation) are always compatible with gates:
```python
cat >> Sgate(0.5)  # squeezed cat
```
<img width="479" alt="Screen Shot 2021-12-07 at 2 03 14 PM" src="https://user-images.githubusercontent.com/8944955/145090219-298ca2ab-92e9-4ac2-beab-33ee33770fb2.png">



## 2. Gates and the right shift operator `>>`

Applying gates to states looks natural, thanks to python's right-shift operator `>>`:
```python
displaced_squeezed = Vacuum(1) >> Sgate(r=0.5) >> Dgate(x=1.0)
```

If you want to apply a gate to specific modes, use the `getitem` format. Here are a few examples:
```python
D = Dgate(y=-0.4)
S = Sgate(r=0.1, phi=0.5)
state = Vacuum(2) >> D[1] >> S[0]  # displacement on mode 1 and squeezing on mode 0

BS = BSgate(theta=1.1)
state = Vacuum(3) >> BS[0,2]  # applying a beamsplitter to modes 0 and 2
state = Vacuum(4) >> S[0,1,2]  # applying the same Sgate in parallel to modes 0, 1 and 2 but not to mode 3
```

## 3. Circuit
When chaining just gates with the right-shift `>>` operator, we create a circuit:
```python
X8 = Sgate(r=[1.0] * 4) >> Interferometer(4)
output = Vacuum(4) >> X8

# lossy X8
noise = lambda: np.random.uniform(size=4)
X8_noisy = (Sgate(r=0.9 + 0.1*noise(), phi=0.1*noise())
                >> Attenuator(0.89 + 0.01*noise())
                >> Interferometer(4)
                >> Attenuator(0.95 + 0.01*noise())
               )

# 2-mode Bloch Messiah decomposition
bloch_messiah = Sgate(r=[0.1,0.2]) >> BSgate(theta=-0.1, phi=2.1) >> Dgate(x=[0.1, -0.4])
my_state = Vacuum(2) >> bloch_messiah
```

## 4. Measurements
In order to perform a measurement, we use the left-shift operator, e.g. `coh << sq` (think of the left-shift on a state as "closing" the circuit).
```python
leftover = Vacuum(4) >> X8 << SqueezedVacuum(r=10.0, phi=np.pi)[2]  # a homodyne measurement of p=0.0 on mode 2
```

Transformations can also be applied in the dual sense by using the left-shift operator `<<`:
```python
Attenuator(0.5) << Coherent(0.1, 0.2) == Coherent(0.1, 0.2) >> Amplifier(2.0)
```
This has the advantage of modelling lossy detectors without applying the loss channel to the state going into the detector, which can be overall faster e.g. if the state is kept pure by doing so.

## 5. Detectors
There are two types of detectors in Mr Mustard. Fock detectors (PNRDetector and ThresholdDetector) and Gaussian detectors (Homodyne, Heterodyne, Generaldyne).

The PNR and Threshold detectors return an array of unnormalized measurement results, meaning that the elements of the array are the density matrices of the leftover systems, conditioned on the outcomes:
```python
results = Gaussian(2) << PNRDetector(efficiency = 0.9, modes = [0])
results[0]  # unnormalized dm of mode 1 conditioned on measuring 0 in mode 0
results[1]  # unnormalized dm of mode 1 conditioned on measuring 1 in mode 0
results[2]  # unnormalized dm of mode 1 conditioned on measuring 2 in mode 0
# etc...
```
The trace of the leftover density matrices will yield the success probability. If multiple modes are measured then there is a corresponding number of indices:
```python
results = Gaussian(3) << PNRDetector(efficiency = [0.9, 0.8], modes = [0,1])
results[2,3]  # unnormalized dm of mode 2 conditioned on measuring 2 in mode 0 and 3 in mode 1
# etc...
```
Set a lower `settings.PNR_INTERNAL_CUTOFF` (default 50) to speed-up computations of the PNR output.

## 6. Comparison operator `==`
States support the comparison operator:
```python
>>> bunched = (Coherent(1.0) & Coherent(1.0)) >> BSgate(np.pi/4)
>>> bunched.get_modes(1) == Coherent(np.sqrt(2.0))
True
```
As well as transformations (gates and circuits):
```python
>>> Dgate(np.sqrt(2)) >> Attenuator(0.5) == Attenuator(0.5) >> Dgate(1.0)
True
```

## 7. State operations and properties
States can be joined using the `&` (and) operator:
```python
Coherent(x=1.0, y=1.0) & Coherent(x=2.0, y=2.0)  # A separable two-mode coherent state

s = SqueezedVacuum(r=1.0)
s4 = s & s & s & s   # four squeezed states
```

Subsystems can be accessed via `get_modes`:
```python
joint = Coherent(x=1.0, y=1.0) & Coherent(x=2.0, y=2.0)
joint.get_modes(0)  # first mode
joint.get_modes(1)  # second mode

swapped = joint.get_modes([1,0])
```

## 8. Fock representation
The Fock representation of a State is obtained via `.ket(cutoffs)` or `.dm(cutoffs)`. For circuits and gates (transformations in general) it's `.U(cutoffs)` or `.choi(cutoffs)`, if available. The Fock representation is exact and it doesn't break differentiability. This means that one can define cost functions on the Fock representation and backpropagate back to the phase space representation.

```python
# Fock representation of a coherent state
Coherent(0.5).ket(cutoffs=[5])   # ket
Coherent(0.5).dm(cutoffs=[5])    # density matrix

Dgate(x=1.0).U(cutoffs=[15])  # truncated unitary matrix
Dgate(x=1.0).choi(cutoffs=[15])  # truncated choi tensor
```

States can be initialized in Fock representation and used as any other state:
```python
my_amplitudes = np.array([0.5, 0.25, -0.5, 0.25, 0.25, 0.5, -0.25] + [0.0]*23)  # notice the buffer
my_state = State(ket=my_amplitudes)
my_state >> Sgate(r=0.5)  # just works
```
<img width="542" alt="Screen Shot 2021-12-06 at 1 44 38 PM" src="https://user-images.githubusercontent.com/8944955/144903799-5b6c1524-4357-4be0-9778-e1f0de6943c1.png">

Alternatively,
```python
my_amplitudes = np.array([0.5, 0.25, -0.5, 0.25, 0.25, 0.5, -0.25])  # no buffer
my_state = State(ket=my_amplitudes)
my_state._cutoffs = [42]  # force the cutoff
my_state >> Sgate(r=0.5)  # works too
```

# The physics module
The physics module contains a growing number of functions that we can apply to states directly. These are made out of the functions that operate on the _representation_ of the state:

- If the state is in Gaussian representation, then internally the physics functions utilize the [physics.gaussian](https://github.com/XanaduAI/MrMustard/blob/main/mrmustard/physics/gaussian.py) module.
- If the state is in Fock representation, then internally the physics functions utilize the [physics.fock](https://github.com/XanaduAI/MrMustard/blob/main/mrmustard/physics/fock.py) module.


# The math module
The math module is the backbone of Mr Mustard. Mr Mustard comes with a plug-and-play backends through a math interface. You can use it as a drop-in replacement for tensorflow or numpy and your code will be plug-and-play too!

Here's an example where the `numpy` backend is used.
```python
import mrmustard.math as math

math.cos(0.1)  # numpy
```

In a different session, we can change the backend to ``tensorflow``.
```python
import mrmustard.math as math
math.change_backend("tensorflow")

math.cos(0.1)  # tensorflow
```

### Optimization
The `mrmustard.training.Optimizer` uses Adam underneath the hood for the optimization of Euclidean parameters, a custom symplectic optimizer for Gaussian gates and states and a unitary/orthogonal optimizer for interferometers.

We can turn any simulation in Mr Mustard into an optimization by marking which parameters we wish to be trainable. Let's take a simple example: synthesizing a displaced squeezed state.

```python
from mrmustard import math
from mrmustard.lab import Dgate, Ggate, Attenuator, Vacuum, Coherent, DisplacedSqueezed
from mrmustard.physics import fidelity
from mrmustard.training import Optimizer

math.change_backend("tensorflow")

D = Dgate(x = 0.1, y = -0.5, x_trainable=True, y_trainable=True)
L = Attenuator(transmissivity=0.5)

# we write a function that takes no arguments and returns the cost
def cost_fn_eucl():
    state_out = Vacuum(1) >> D >> L
    return 1 - fidelity(state_out, Coherent(0.1, 0.5))

G = Ggate(num_modes=1, symplectic_trainable=True)
def cost_fn_sympl():
    state_out = Vacuum(1) >> G >> D >> L
    return 1 - fidelity(state_out, DisplacedSqueezed(r=0.3, phi=1.1, x=0.4, y=-0.2))

# For illustration, here the Euclidean optimization doesn't include squeezing 
opt = Optimizer(symplectic_lr=0.1, euclidean_lr=0.01)
opt.minimize(cost_fn_eucl, by_optimizing=[D])  # using Adam for D

# But the symplectic optimization always does
opt = Optimizer(symplectic_lr=0.1, euclidean_lr=0.01)
opt.minimize(cost_fn_sympl, by_optimizing=[G,D])  # uses Adam for D and the symplectic opt for G
```

## Contribution guidelines

- Write new [tests](https://github.com/XanaduAI/MrMustard/tree/main/tests) if you add new functionality or fix a bug.
- Type-hint the code (quantum-specific and math-specific type hints (like `Covmat` or `Tensor`) are in `mrmustard.utils.types`).
- Write informative docstrings using the Args/Returns pattern.

You can raise [issues](https://github.com/XanaduAI/MrMustard/issues) to keep track of bugs. We also have a [kanban board](https://github.com/XanaduAI/MrMustard/projects/1) to keep track of projects (you can [make your own](https://github.com/XanaduAI/MrMustard/projects) too).
## Architecture of Mr Mustard
Mr Mustard is split into 3 components:

### 1. [lab](https://github.com/XanaduAI/MrMustard/blob/main/mrmustard/lab)
The lab module contains states, gates and detectors. The code in these objects uses the functionality provided by the physics module (see below) and does not care how things are actually computed. The code in the lab module should not use the math module directly.

### 2. [physics](https://github.com/XanaduAI/MrMustard/blob/main/mrmustard/physics)
The physics module contains the implementation of all of the functionality used in the lab module. The physics module talks to an interface for a math backend, which is defined in [`math_interface.py`](https://github.com/XanaduAI/MrMustard/blob/main/mrmustard/physics/math_interface.py).

### 3. [math](https://github.com/XanaduAI/MrMustard/blob/main/mrmustard/math)
The math module contains the concrete implementations of the math interface. At the moment we have [Numpy](https://github.com/XanaduAI/MrMustard/blob/main/mrmustard/math/backend_numpy.py) and [Tensorflow](https://github.com/XanaduAI/MrMustard/blob/main/mrmustard/math/backend_tensorflow.py).

module LeftoverModeGrad

import ..GetPrecision
import ..CompactFock_HelperFunctions

function calc_dA_dB(m, n, i, arr_read_pivot, read_GB, G_in_adapted, A_adapted, B, K_i, K_l_adapted, arr_read_pivot_dA, G_in_dA_adapted, arr_read_pivot_dB, G_in_dB_adapted, l_range)
    """Apply eqs. 16 & 17 (of https://doi.org/10.22331/q-2023-08-29-1097) for a single Fock amplitude"""
    dA = arr_read_pivot_dA[m, n, read_GB...,:,:] .* B[i]
    dB = arr_read_pivot_dB[m, n, read_GB...,:] .* B[i]
    dB[i] += arr_read_pivot[m, n, read_GB...]
    for (l_prime, l) in enumerate(l_range)
        dA += (K_l_adapted[l_prime] * A_adapted[l_prime]) .* G_in_dA_adapted[l_prime,:,:]
        dB += (K_l_adapted[l_prime] * A_adapted[l_prime]) .* G_in_dB_adapted[l_prime,:]
        dA[i, l] += G_in_adapted[l_prime]
    end
    return dA ./ K_i[i - 2], dB ./ K_i[i - 2]
end

function write_block_grad(i, write, arr_read_pivot, read_GB, G_in, A, B, K_i, K_l, cutoff_leftoverMode, arr_write_dA, arr_read_pivot_dA, G_in_dA, arr_write_dB, arr_read_pivot_dB, G_in_dB, SQRT)
    """
    Apply eqs. 16 & 17 (of https://doi.org/10.22331/q-2023-08-29-1097)
    to blocks of Fock amplitudes (of shape cutoff_leftoverMode x cutoff_leftoverMode)
    """
    m, n = 1, 1
    l_range = 3:size(A)[2]
    A_adapted = A[i, 3:end]
    G_in_adapted = G_in[1, 1, :]
    G_in_dA_adapted = G_in_dA[1,1,:,:,:]
    G_in_dB_adapted = G_in_dB[1,1,:,:]
    K_l_adapted = K_l
    arr_write_dA[1, 1, write...,:,:], arr_write_dB[1, 1, write...,:] = calc_dA_dB(m, n, i, arr_read_pivot, read_GB, G_in_adapted, A_adapted, B, K_i, K_l_adapted, arr_read_pivot_dA, G_in_dA_adapted, arr_read_pivot_dB, G_in_dB_adapted, l_range)

    m = 1
    l_range = 2:size(A)[2]
    A_adapted = A[i, 2:end]
    for n in 2:cutoff_leftoverMode
        K_l_adapted = vcat(SQRT[n], K_l)
        G_in_adapted = vcat(arr_read_pivot[1, n - 1, read_GB...] * SQRT[n], G_in[1, n, :])
        G_in_dA_adapted = vcat(reshape(arr_read_pivot_dA[1, n - 1, read_GB...,:,:], (1, size(A)...)), G_in_dA[1,n,:,:,:])
        G_in_dB_adapted = vcat(reshape(arr_read_pivot_dB[1, n - 1, read_GB...,:], (1, size(B)...)), G_in_dB[1,n,:,:])
        arr_write_dA[1, n, write...,:,:], arr_write_dB[1, n, write...,:] = calc_dA_dB(m, n, i, arr_read_pivot, read_GB, G_in_adapted, A_adapted, B, K_i, K_l_adapted, arr_read_pivot_dA, G_in_dA_adapted, arr_read_pivot_dB, G_in_dB_adapted, l_range)
    end

    n = 1
    l_range = [2:size(A)[2]...]
    l_range[1] = 1
    A_adapted = vcat(A[i, 1], A[i, 3:end])
    for m in 2:cutoff_leftoverMode
        K_l_adapted = vcat(SQRT[m], K_l)
        G_in_adapted = vcat(arr_read_pivot[m - 1, 1, read_GB...] * SQRT[m], G_in[m, 1, :])
        G_in_dA_adapted = vcat(reshape(arr_read_pivot_dA[m - 1, 1, read_GB...,:,:], (1, size(A)...)), G_in_dA[m, 1,:,:,:])
        G_in_dB_adapted = vcat(reshape(arr_read_pivot_dB[m - 1, 1, read_GB...,:], (1, size(B)...)), G_in_dB[m, 1,:,:])
        arr_write_dA[m, 1, write...,:,:], arr_write_dB[m, 1, write...,:] = calc_dA_dB(m, n, i, arr_read_pivot, read_GB, G_in_adapted, A_adapted, B, K_i, K_l_adapted, arr_read_pivot_dA, G_in_dA_adapted, arr_read_pivot_dB, G_in_dB_adapted, l_range)
    end

    l_range = 1:size(A)[2]
    A_adapted = A[i, :]
    for m in 2:cutoff_leftoverMode
        for n in 2:cutoff_leftoverMode
            K_l_adapted = vcat(SQRT[m], SQRT[n], K_l)
            G_in_adapted = vcat(arr_read_pivot[m - 1, n, read_GB...] * SQRT[m], arr_read_pivot[m, n - 1, read_GB...] * SQRT[n], G_in[m, n, :])
            G_in_dA_adapted = vcat(reshape(arr_read_pivot_dA[m - 1, n, read_GB...,:,:], (1, size(A)...)), reshape(arr_read_pivot_dA[m, n - 1, read_GB...,:,:], (1, size(A)...)), G_in_dA[m, n,:,:,:])
            G_in_dB_adapted = vcat(reshape(arr_read_pivot_dB[m - 1, n, read_GB...,:], (1, size(B)...)), reshape(arr_read_pivot_dB[m, n - 1, read_GB...,:], (1, size(B)...)), G_in_dB[m, n,:,:])
            arr_write_dA[m, n, write...,:,:], arr_write_dB[m, n, write...,:] = calc_dA_dB(m, n, i, arr_read_pivot, read_GB, G_in_adapted, A_adapted, B, K_i, K_l_adapted, arr_read_pivot_dA, G_in_dA_adapted, arr_read_pivot_dB, G_in_dB_adapted, l_range)
        end
    end
    return arr_write_dA, arr_write_dB
end

function read_block(arr_write, arr_write_dA, arr_write_dB, idx_write, arr_read, arr_read_dA, arr_read_dB, idx_read_tail)
    """
    Read the blocks of Fock amplitudes (of shape cutoff_leftoverMode x cutoff_leftoverMode)
    and their derivatives w.r.t A and B and write them to G_in, G_in_dA, G_in_dB
    """
    arr_write[:, :, idx_write] .= arr_read[:, :, idx_read_tail...]
    arr_write_dA[:, :, idx_write, :, :] .= arr_read_dA[:, :, idx_read_tail...,:, :]
    arr_write_dB[:, :, idx_write, :] .= arr_read_dB[:, :, idx_read_tail...,:]
    return arr_write, arr_write_dA, arr_write_dB
end


function use_offDiag_pivot_grad!(A, B, M, cutoff_leftoverMode, cutoffs_tail, params, d, arr0, arr2, arr1010, arr1001, arr1, arr0_dA, arr2_dA, arr1010_dA, arr1001_dA, arr1_dA, arr0_dB, arr2_dB, arr1010_dB, arr1001_dB, arr1_dB, T, SQRT)
    """Given params=(a,b,c,...), apply the eqs. 16 & 17 (of https://doi.org/10.22331/q-2023-08-29-1097)
    for the pivots [a+1,a,b,b,c,c,...] / [a,a,b+1,b,c,c,...] / [a,a,b,b,c+1,c,...] / ..."""
    pivot = CompactFock_HelperFunctions.repeat_twice(params)
    pivot[2 * d - 1] += 1
    K_l = SQRT[pivot] # julia indexing counters extra zero in SQRT
    K_i = SQRT[pivot .+ 1] # julia indexing counters extra zero in SQRT
    G_in = zeros(Complex{T}, cutoff_leftoverMode, cutoff_leftoverMode, 2 * M)
    G_in_dA = zeros(Complex{T}, size(G_in)..., size(A)...)
    G_in_dB = zeros(Complex{T}, size(G_in)..., size(B)...)

    ########## READ ##########
    read_GB = (2 * d - 1, params...)
    GB = zeros(Complex{T}, cutoff_leftoverMode, cutoff_leftoverMode, length(B))
    for m in 1:cutoff_leftoverMode
        for n in 1:cutoff_leftoverMode
            GB[m, n, :] = arr1[m, n, read_GB...] .* B
        end
    end

    # Array0
    G_in, G_in_dA, G_in_dB = read_block(G_in, G_in_dA, G_in_dB, 2 * d - 1, arr0, arr0_dA, arr0_dB, params)

    # read from Array2
    if params[d] > 1
        params_adapted = collect(params)
        params_adapted[d] -= 1
        G_in, G_in_dA, G_in_dB = read_block(G_in, G_in_dA, G_in_dB, 2 * d, arr2, arr2_dA, arr2_dB, (d,params_adapted...))
    end

    # read from Array11
    for i in d+1:M  # i>d
        if params[i] > 1
            params_adapted = collect(params)
            params_adapted[i] -= 1
            G_in, G_in_dA, G_in_dB = read_block(G_in, G_in_dA, G_in_dB, 2 * i - 1, arr1001, arr1001_dA, arr1001_dB, (d, i - d,params_adapted...))
            G_in, G_in_dA, G_in_dB = read_block(G_in, G_in_dA, G_in_dB, 2 * i, arr1010, arr1010_dA, arr1010_dB, (d, i - d,params_adapted...))
        end
    end

    ########## WRITE ##########
    for m in 1:cutoff_leftoverMode
        for n in 1:cutoff_leftoverMode
            G_in[m, n, :] .*= K_l
        end
    end

    # Array0
    write = collect(params)
    write[d] += 1
    arr0_dA, arr0_dB = write_block_grad(2 * d + 2, write, arr1, read_GB, G_in, A, B, K_i, K_l, cutoff_leftoverMode, arr0_dA, arr1_dA, G_in_dA, arr0_dB, arr1_dB, G_in_dB, SQRT)

    # Array2
    if params[d] + 1 < cutoffs_tail[d]
        write = (d, params...)
        arr2_dA, arr2_dB = write_block_grad(2 * d + 1, write, arr1, read_GB, G_in, A, B, K_i, K_l, cutoff_leftoverMode, arr2_dA, arr1_dA, G_in_dA, arr2_dB, arr1_dB, G_in_dB, SQRT)
    end

    # Array11
    for i in d+1:M
        if params[i] < cutoffs_tail[i]
            write = (d, i - d, params...)
            arr1010_dA, arr1010_dB = write_block_grad(2 * i + 1, write, arr1, read_GB, G_in, A, B, K_i, K_l, cutoff_leftoverMode, arr1010_dA, arr1_dA, G_in_dA, arr1010_dB, arr1_dB, G_in_dB, SQRT)
            arr1001_dA, arr1001_dB = write_block_grad(2 * i + 2, write, arr1, read_GB, G_in, A, B, K_i, K_l, cutoff_leftoverMode, arr1001_dA, arr1_dA, G_in_dA, arr1001_dB, arr1_dB, G_in_dB, SQRT)
        end
    end
end

function use_diag_pivot_grad!(A, B, M, cutoff_leftoverMode, cutoffs_tail, params, arr0, arr1, arr0_dA, arr1_dA, arr0_dB, arr1_dB, T, SQRT)
    pivot = CompactFock_HelperFunctions.repeat_twice(params)
    """Given params=(a,b,c,...), apply the eqs. 16 & 17 (of https://doi.org/10.22331/q-2023-08-29-1097)
     for the pivot [a,a,b,b,c,c...]"""
    K_l = SQRT[pivot] # julia indexing counters extra zero in SQRT
    K_i = SQRT[pivot .+ 1] # julia indexing counters extra zero in SQRT
    G_in = zeros(Complex{T}, cutoff_leftoverMode, cutoff_leftoverMode, 2*M)
    G_in_dA = zeros(Complex{T}, size(G_in)..., size(A)...)
    G_in_dB = zeros(Complex{T}, size(G_in)..., size(B)...)

    ########## READ ##########
    read_GB = params
    GB = zeros(Complex{T}, cutoff_leftoverMode, cutoff_leftoverMode, length(B))
    for m in 1:cutoff_leftoverMode
        for n in 1:cutoff_leftoverMode
            GB[m, n, :] = arr0[m, n, read_GB...] .* B
        end
    end

    # Array1
    for i in 1:2*M
        if params[(i-1)÷2+1] > 1
            params_adapted = collect(params)
            params_adapted[(i-1)÷2+1] -= 1
            read = tuple(i+1-2*((i-1) % 2), params_adapted...)
            G_in, G_in_dA, G_in_dB = read_block(G_in, G_in_dA, G_in_dB, i, arr1, arr1_dA, arr1_dB, read)
        end
    end

    ########## WRITE ##########
    for m in 1:cutoff_leftoverMode
        for n in 1:cutoff_leftoverMode
            G_in[m, n, :] .*= K_l
        end
    end

    # Array1
    for i in 1:2*M
        if params[(i-1)÷2+1] < cutoffs_tail[(i-1)÷2+1]
            # this if statement prevents a few elements from being written that will never be read
            if i ≠ 2 || params[1] + 1 < cutoffs_tail[1]
                write = tuple(i,params...)
                arr1_dA, arr1_dB = write_block_grad(i + 2, write, arr0, read_GB, G_in, A, B, K_i, K_l, cutoff_leftoverMode, arr1_dA, arr0_dA, G_in_dA, arr1_dB, arr0_dB, G_in_dB, SQRT)
            end
        end
    end
end

function fill_firstMode_PNRzero!(arr0,arr0_dA,arr0_dB,A,B,M,cutoff_leftoverMode,SQRT)
    """fill first mode when all PNR detection values are equal to zero"""
    one_tuple = tuple(fill(1,M-1)...)

    for m in 1:cutoff_leftoverMode - 1
        arr0_dA[m + 1, 1, one_tuple..., :, :] = arr0_dA[m, 1, one_tuple..., :, :] .* B[1]
        arr0_dB[m + 1, 1, one_tuple..., :] = arr0_dB[m, 1, one_tuple..., :] .* B[1]
        arr0_dB[m + 1, 1, one_tuple..., 1] += arr0[m, 1, one_tuple...] 
        if m != 1
            arr0_dA[m + 1, 1, one_tuple..., :, :] += SQRT[m] .* A[1, 1] .* arr0_dA[m - 1, 1, one_tuple..., :, :]
            arr0_dA[m + 1, 1, one_tuple..., 1, 1] += SQRT[m] .* arr0[m - 1, 1, one_tuple...] 
            arr0_dB[m + 1, 1, one_tuple..., :] += SQRT[m] .* A[1, 1] .* arr0_dB[m - 1, 1, one_tuple..., :]
        end
        arr0_dA[m + 1, 1, one_tuple..., :, :] ./= SQRT[m + 1]
        arr0_dB[m + 1, 1, one_tuple..., :] ./= SQRT[m + 1]
    end

    for m in 1:cutoff_leftoverMode
        for n in 1:cutoff_leftoverMode - 1
            arr0_dA[m, n + 1, one_tuple..., :, :] = arr0_dA[m, n, one_tuple..., :, :] .* B[2]
            arr0_dB[m, n + 1, one_tuple..., :] = arr0_dB[m, n, one_tuple..., :] .* B[2]
            arr0_dB[m, n + 1, one_tuple..., 2] += arr0[m, n, one_tuple...]
            if m != 1
                arr0_dA[m, n + 1, one_tuple..., :, :] += SQRT[m] .* A[2, 1] .* arr0_dA[m - 1, n, one_tuple..., :, :]
                arr0_dA[m, n + 1, one_tuple..., 2, 1] += SQRT[m] .* arr0[m - 1, n, one_tuple...]
                arr0_dB[m, n + 1, one_tuple..., :] += SQRT[m] .* A[2, 1] .* arr0_dB[m - 1, n, one_tuple..., :]
                
            end
            if n != 1
                arr0_dA[m, n + 1, one_tuple..., :, :] += SQRT[n] .* A[2, 2] .* arr0_dA[m, n - 1, one_tuple..., :, :]
                arr0_dA[m, n + 1, one_tuple..., 2, 2] += SQRT[n] .* arr0[m, n - 1, one_tuple...]
                arr0_dB[m, n + 1, one_tuple..., :] += SQRT[n] .* A[2, 2] .* arr0_dB[m, n - 1, one_tuple..., :]
            end
            arr0_dA[m, n + 1, one_tuple..., :, :] ./= SQRT[n + 1]
            arr0_dB[m, n + 1, one_tuple..., :] ./= SQRT[n + 1]
        end
    end
end

function fock_1leftoverMode_grad(
    A::AbstractMatrix{Complex{Float64}}, 
    B::AbstractVector{Complex{Float64}},
    arr0::AbstractArray{Complex{Float64}}, 
    arr2::AbstractArray{Complex{Float64}}, 
    arr1010::AbstractArray{Complex{Float64}}, 
    arr1001::AbstractArray{Complex{Float64}}, 
    arr1::AbstractArray{Complex{Float64}},
    precision_bits::Int64
    )
    """Returns the gradients of the density matrices in the upper, undetected mode of a circuit when all other modes
    are PNR detected (according to algorithm 2 of https://doi.org/10.22331/q-2023-08-29-1097)
    Args:
        A, B: required input for recurrence relation
        Submatrices of the Fock representation. Each submatrix contains Fock indices of a certain type.
            arr0 --> type: [a,a,b,b,c,c...]
            arr2 --> type: [a+2,a,b,b,c,c...] / [a,a,b+2,b,c,c...] / ...
            arr1010 --> type: [a+1,a,b+1,b,c,c,...] / [a+1,a,b,b,c+1,c,...] / [a,a,b+1,b,c+1,c,...] / ...
            arr1001 --> type: [a+1,a,b,b+1,c,c,...] / [a+1,a,b,b,c,c+1,...] / [a,a,b+1,b,c,c+1,...] / ...
            arr1 --> type: [a+1,a,b,b,c,c...] / [a,a+1,b,b,c,c...] / [a,a,b+1,b,c,c...] / ...
        precision_bits: number of bits used to represent a single Fock amplitude
    Returns:
        arr0_dA, arr0_dB: derivatives of arr0 w.r.t A and B
    """
    
    T = GetPrecision.get_dtype(precision_bits)
    SQRT = GetPrecision.SQRT_dict[precision_bits]
    
    cutoffs = size(arr0)[2:end]
    M = length(cutoffs)
    cutoff_leftoverMode = cutoffs[1]
    cutoffs_tail = cutoffs[2:end]

    arr0_dA = zeros(Complex{T}, size(arr0)..., size(A)...)
    arr2_dA = zeros(Complex{T}, size(arr2)..., size(A)...)
    arr1010_dA = zeros(Complex{T}, size(arr1010)..., size(A)...)
    arr1001_dA = zeros(Complex{T}, size(arr1001)..., size(A)...)
    arr1_dA = zeros(Complex{T}, size(arr1)..., size(A)...)
    arr0_dB = zeros(Complex{T}, size(arr0)..., size(B)...)
    arr2_dB = zeros(Complex{T}, size(arr2)..., size(B)...)
    arr1010_dB = zeros(Complex{T}, size(arr1010)..., size(B)...)
    arr1001_dB = zeros(Complex{T}, size(arr1001)..., size(B)...)
    arr1_dB = zeros(Complex{T}, size(arr1)..., size(B)...)

    fill_firstMode_PNRzero!(arr0,arr0_dA,arr0_dB,A,B,M,cutoff_leftoverMode,SQRT)

    dict_params = CompactFock_HelperFunctions.construct_dict_params(cutoffs_tail)
    for sum_params in 0:sum(cutoffs_tail)-1
        for params in dict_params[sum_params]
            # diagonal pivots: aa,bb,cc,...
            if (cutoffs_tail[1] == 1) || (params[1] < cutoffs_tail[1]) # julia indexing!
                use_diag_pivot_grad!(A,B,M - 1,cutoff_leftoverMode,cutoffs_tail,params,arr0,arr1,arr0_dA,arr1_dA,arr0_dB,arr1_dB,T,SQRT)
            end
            # off-diagonal pivots: d=1: (a+1)a,bb,cc,... | d=2: 00,(b+1)b,cc,... | d=3: 00,00,(c+1)c,... | ...
            for d in 1:M - 1
                if all(params[1:d-1] .== 1) && (params[d] < cutoffs_tail[d])
                    use_offDiag_pivot_grad!(A,B,M - 1,cutoff_leftoverMode,cutoffs_tail,params,d,arr0,arr2,arr1010,arr1001,arr1,arr0_dA,arr2_dA,arr1010_dA,arr1001_dA,arr1_dA,arr0_dB,arr2_dB,arr1010_dB,arr1001_dB,arr1_dB,T,SQRT)
                end
            end
        end
    end

    return Complex{Float64}.(arr0_dA), Complex{Float64}.(arr0_dB)
end

end # end module

module LeftoverModeAmps

import ..GetPrecision
import ..CompactFock_HelperFunctions

function write_block!(i, arr_write, write, arr_read_pivot, read_GB, G_in, GB, A, K_i, cutoff_leftoverMode, SQRT)
    """
    Apply the recurrence relation to blocks of Fock amplitudes (of shape cutoff_leftoverMode x cutoff_leftoverMode)
    (cfr. algorithm 2 of https://doi.org/10.22331/q-2023-08-29-1097)
    """
    m, n = 1, 1
    A_adapted = A[i, 3:end]
    G_in_adapted = G_in[1, 1, :]
    arr_write[1, 1, write...] = (GB[1, 1, i] + sum(A_adapted .* G_in_adapted)) / K_i[i - 2]

    m = 1
    A_adapted = A[i, 2:end]
    for n in 2:cutoff_leftoverMode
        G_in_adapted = vcat(arr_read_pivot[1, n - 1, read_GB...] * SQRT[n], G_in[1, n, :])
        arr_write[1, n, write...] = (GB[1, n, i] + sum(A_adapted .* G_in_adapted)) / K_i[i - 2]
    end

    n = 1
    A_adapted = vcat(A[i, 1], A[i, 3:end])
    for m in 2:cutoff_leftoverMode
        G_in_adapted = vcat(arr_read_pivot[m - 1, 1, read_GB...] * SQRT[m], G_in[m, 1, :])
        arr_write[m, 1, write...] = (GB[m, 1, i] + sum(A_adapted .* G_in_adapted)) / K_i[i - 2]
    end

    A_adapted = A[i, :]
    for m in 2:cutoff_leftoverMode
        for n in 2:cutoff_leftoverMode
            G_in_adapted = vcat(arr_read_pivot[m - 1, n, read_GB...] * SQRT[m], arr_read_pivot[m, n - 1, read_GB...] * SQRT[n], G_in[m, n, :])
            arr_write[m, n, write...] = (GB[m, n, i] + sum(A_adapted .* G_in_adapted)) / K_i[i - 2]
        end
    end
end

function use_offDiag_pivot!(A, B, M, cutoff_leftoverMode, cutoffs_tail, params, d, arr0, arr2, arr1010, arr1001, arr1, T, SQRT)
    """Given params=(a,b,c,...), apply the recurrence relation for the pivots
    [a+1,a,b,b,c,c,...] / [a,a,b+1,b,c,c,...] / [a,a,b,b,c+1,c,...] / ..."""
    pivot = CompactFock_HelperFunctions.repeat_twice(params)
    pivot[2 * d - 1] += 1
    K_l = SQRT[pivot] # julia indexing counters extra zero in SQRT
    K_i = SQRT[pivot .+ 1] # julia indexing counters extra zero in SQRT
    G_in = zeros(Complex{T}, cutoff_leftoverMode, cutoff_leftoverMode, 2 * M)

    ########## READ ##########
    read_GB = tuple(2 * d - 1, params...)
    GB = zeros(Complex{T}, cutoff_leftoverMode, cutoff_leftoverMode, length(B))
    for m in 1:cutoff_leftoverMode
        for n in 1:cutoff_leftoverMode
            GB[m, n, :] = arr1[m, n, read_GB...] .* B
        end
    end

    # Array0
    G_in[:, :, 2 * d - 1] .= arr0[:, :, params...]
    

    # read from Array2
    if params[d] > 1
        params_adapted = collect(params)
        params_adapted[d] -= 1
        G_in[:, :, 2 * d] .= arr2[:, :, d, params_adapted...] # read block
    end

    # read from Array11
    for i in d+1:M  # i>d
        if params[i] > 1
            params_adapted = collect(params)
            params_adapted[i] -= 1
            G_in[:, :, 2 * i - 1] .= arr1001[:, :, d, i - d, params_adapted...] # read block
            G_in[:, :, 2 * i] .= arr1010[:, :, d, i - d, params_adapted...] # read block
        end
    end

    ########## WRITE ##########
    for m in 1:cutoff_leftoverMode
        for n in 1:cutoff_leftoverMode
            G_in[m, n, :] .*= K_l
        end
    end

    # Array0
    write = collect(params)
    write[d] += 1
    write_block!(2 * d + 2, arr0, write, arr1, read_GB, G_in, GB, A, K_i, cutoff_leftoverMode, SQRT)

    # Array2
    if params[d] + 1 < cutoffs_tail[d]
        write = (d, params...)
        write_block!(2 * d + 1, arr2, write, arr1, read_GB, G_in, GB, A, K_i, cutoff_leftoverMode, SQRT)
    end

    # Array11
    for i in d+1:M
        if params[i] < cutoffs_tail[i]
            write = (d, i - d, params...)
            write_block!(2 * i + 1, arr1010, write, arr1, read_GB, G_in, GB, A, K_i, cutoff_leftoverMode, SQRT)
            write_block!(2 * i + 2, arr1001, write, arr1, read_GB, G_in, GB, A, K_i, cutoff_leftoverMode, SQRT)
        end
    end
end

function use_diag_pivot!(A, B, M, cutoff_leftoverMode, cutoffs_tail, params, arr0, arr1, T, SQRT)
    """Given params=(a,b,c,...), apply the recurrence relation for the pivot [a,a,b,b,c,c...]"""
    pivot = CompactFock_HelperFunctions.repeat_twice(params)
    K_l = SQRT[pivot] # julia indexing counters extra zero in SQRT
    K_i = SQRT[pivot .+ 1] # julia indexing counters extra zero in SQRT
    G_in = zeros(Complex{T}, cutoff_leftoverMode, cutoff_leftoverMode, 2*M)

    ########## READ ##########
    read_GB = params
    GB = zeros(Complex{T}, cutoff_leftoverMode, cutoff_leftoverMode, length(B))
    for m in 1:cutoff_leftoverMode
        for n in 1:cutoff_leftoverMode
            GB[m, n, :] = arr0[m, n, read_GB...] .* B
        end
    end

    # Array1
    for i in 1:2*M
        if params[(i-1)÷2+1] > 1
            params_adapted = collect(params)
            params_adapted[(i-1)÷2+1] -= 1
            G_in[:, :, i] .= arr1[:, :, i+1-2*((i-1) % 2), params_adapted...] # read block
        end
    end

    ########## WRITE ##########
    for m in 1:cutoff_leftoverMode
        for n in 1:cutoff_leftoverMode
            G_in[m, n, :] .*= K_l
        end
    end

    # Array1
    for i in 1:2*M
        if params[(i-1)÷2+1] < cutoffs_tail[(i-1)÷2+1]
            # this if statement prevents a few elements from being written that will never be read
            if i ≠ 2 || params[1] + 1 < cutoffs_tail[1]
                write = tuple(i,params...)
                write_block!(i + 2, arr1, write, arr0, read_GB, G_in, GB, A, K_i, cutoff_leftoverMode, SQRT)
            end
        end
    end
end

function fill_firstMode_PNRzero!(arr0,A,B,M,cutoff_leftoverMode,SQRT)
    # fill first mode for all PNR detections equal to zero
    one_tuple = tuple(fill(1,M-1)...)
    for m in 1:cutoff_leftoverMode-1
        arr0[m + 1, 1, one_tuple...] = (arr0[m, 1, one_tuple...] * B[1]) / SQRT[m + 1]
        if m != 1
            arr0[m + 1, 1, one_tuple...] += (SQRT[m] * A[1, 1] * arr0[m - 1, 1, one_tuple...]) / SQRT[m + 1]
        end
    end
    for m in 1:cutoff_leftoverMode
        for n in 1:cutoff_leftoverMode-1
            arr0[m, n + 1, one_tuple...] = (arr0[m, n, one_tuple...] * B[2]) / SQRT[n + 1]
            if m != 1
                arr0[m, n + 1, one_tuple...] += (SQRT[m] * A[2, 1] * arr0[m - 1, n, one_tuple...]) / SQRT[n + 1]
            end
            if n != 1
                arr0[m, n + 1, one_tuple...] += (SQRT[n] * A[2, 2] * arr0[m, n - 1, one_tuple...]) / SQRT[n + 1]
            end
        end
    end
end

function fock_1leftoverMode_amps(
    A::AbstractMatrix{Complex{Float64}}, 
    B::AbstractVector{Complex{Float64}}, 
    G0::Complex{Float64}, 
    cutoffs::Tuple,
    precision_bits::Int64
    )
    """Returns the density matrices in the upper, undetected mode of a circuit when all other modes are PNR detected
    according to algorithm 2 of https://doi.org/10.22331/q-2023-08-29-1097
    Args:
        A, B, G0: required input for recurrence relation
        cutoffs: upper bounds for the number of photons in each mode
        precision_bits: number of bits used to represent a single Fock amplitude
    Returns:
        Submatrices of the Fock representation. Each submatrix contains Fock indices of a certain type.
        arr0 --> type: [a,a,b,b,c,c...]
        arr2 --> type: [a+2,a,b,b,c,c...] / [a,a,b+2,b,c,c...] / ...
        arr1010 --> type: [a+1,a,b+1,b,c,c,...] / [a+1,a,b,b,c+1,c,...] / [a,a,b+1,b,c+1,c,...] / ...
        arr1001 --> type: [a+1,a,b,b+1,c,c,...] / [a+1,a,b,b,c,c+1,...] / [a,a,b+1,b,c,c+1,...] / ...
        arr1 --> type: [a+1,a,b,b,c,c...] / [a,a+1,b,b,c,c...] / [a,a,b+1,b,c,c...] / ...
    """
    
    T = GetPrecision.get_dtype(precision_bits)
    SQRT = GetPrecision.SQRT_dict[precision_bits]

    M = length(cutoffs)
    cutoff_leftoverMode = cutoffs[1]
    cutoffs_tail = cutoffs[2:end]

    arr0 = zeros(Complex{T}, cutoff_leftoverMode, cutoff_leftoverMode, cutoffs_tail...)
    arr0[fill(1,M+1)...] = G0
    arr2 = zeros(Complex{T}, cutoff_leftoverMode, cutoff_leftoverMode, M - 1, cutoffs_tail...)
    arr1 = zeros(Complex{T}, cutoff_leftoverMode, cutoff_leftoverMode, 2 * (M - 1), cutoffs_tail...)
    arr1010 = zeros(Complex{T}, cutoff_leftoverMode, cutoff_leftoverMode, M - 1, M - 2, cutoffs_tail...)
    arr1001 = zeros(Complex{T}, cutoff_leftoverMode, cutoff_leftoverMode, M - 1, M - 2, cutoffs_tail...)


    # fill first mode for all PNR detections equal to zero
    fill_firstMode_PNRzero!(arr0,A,B,M,cutoff_leftoverMode,SQRT)

    dict_params = CompactFock_HelperFunctions.construct_dict_params(cutoffs_tail)
    for sum_params in 0:sum(cutoffs_tail)-1
        for params in dict_params[sum_params]
            # diagonal pivots: aa,bb,cc,...
            if (cutoffs_tail[1] == 1) || (params[1] < cutoffs_tail[1]) # julia indexing!
                use_diag_pivot!(A, B, M - 1, cutoff_leftoverMode, cutoffs_tail, params, arr0, arr1, T, SQRT)
            end
            # off-diagonal pivots: d=1: (a+1)a,bb,cc,... | d=2: 00,(b+1)b,cc,... | d=3: 00,00,(c+1)c,... | ...
            for d in 1:M - 1
                if all(params[1:d-1] .== 1) && (params[d] < cutoffs_tail[d])
                    use_offDiag_pivot!(A,B,M - 1,cutoff_leftoverMode,cutoffs_tail,params,d,arr0,arr2,arr1010,arr1001,arr1,T,SQRT)
                end
            end
        end
    end

    return Complex{Float64}.(arr0), Complex{Float64}.(arr2), Complex{Float64}.(arr1010), Complex{Float64}.(arr1001), Complex{Float64}.(arr1)
end

end # end module

module DiagonalAmps

import ..GetPrecision
import ..CompactFock_HelperFunctions

function use_offDiag_pivot!(A, B, M, cutoffs, params, d, arr0, arr2, arr1010, arr1001, arr1, T, SQRT)
    """Given params=(a,b,c,...), apply the recurrence relation for the pivots
    [a+1,a,b,b,c,c,...] / [a,a,b+1,b,c,c,...] / [a,a,b,b,c+1,c,...] / ..."""
    pivot = CompactFock_HelperFunctions.repeat_twice(params)
    pivot[2 * d - 1] += 1

    K_l = SQRT[pivot] # julia indexing counters extra zero in SQRT
    K_i = SQRT[pivot .+ 1] # julia indexing counters extra zero in SQRT
    
    G_in = zeros(Complex{T}, 2 * M)

    ########## READ ##########
    GB = arr1[2 * d - 1, params...] .* B

    # Array0
    G_in[2 * d - 1] = arr0[params...]

    # read from Array2
    if params[d] > 1
        params_adapted = collect(params)
        params_adapted[d] -= 1
        G_in[2 * d] = arr2[d, params_adapted...]
    end

    # read from Array11
    for i in d+1:M # i>d
        if params[i] > 1
            params_adapted = collect(params)
            params_adapted[i] -= 1
            G_in[2 * i - 1] = arr1001[d, i - d, params_adapted...]
            G_in[2 * i] = arr1010[d, i - d, params_adapted...]
        end
    end

    ########## WRITE ##########
    G_in .*= K_l

    # Array0
    params_adapted = collect(params)
    params_adapted[d] += 1
    arr0[params_adapted...] = (GB[2 * d] .+ sum(A[2 * d,:] .* G_in)) / K_i[2 * d]

    # Array2
    if params[d] + 1 < cutoffs[d]
        arr2[d, params...] = (GB[2 * d - 1] .+ sum(A[2 * d - 1,:] .* G_in)) / K_i[2 * d - 1]
    end

    # Array11
    for i in d+1:M # i>d
        if params[i] < cutoffs[i]
            arr1010[d, i - d, params...] = (GB[2 * i - 1] .+ sum(A[2 * i - 1,:] .* G_in)) / K_i[2 * i - 1]
            arr1001[d, i - d, params...] = (GB[2 * i] .+ sum(A[2 * i,:] .* G_in)) / K_i[2 * i]
        end
    end
end

function use_diag_pivot!(A, B, M, cutoffs, params, arr0, arr1, T, SQRT)
    """Given params=(a,b,c,...), apply the recurrence relation for the pivot [a,a,b,b,c,c...]"""
    pivot = CompactFock_HelperFunctions.repeat_twice(params)
    K_l = SQRT[pivot] # julia indexing counters extra zero in SQRT
    K_i = SQRT[pivot .+ 1] # julia indexing counters extra zero in SQRT
    G_in = zeros(Complex{T}, 2*M)

    ########## READ ##########
    GB = arr0[params...] .* B

    # Array1
    for i in 1:2*M
        if params[(i-1)÷2+1] > 1
            params_adapted = collect(params)
            params_adapted[(i-1)÷2+1] -= 1
            G_in[i] = arr1[i+1-2*((i-1) % 2), params_adapted...]
        end
    end

    ########## WRITE ##########
    G_in .*= K_l

    # Array1
    for i in 1:2*M
        if params[(i-1)÷2+1] < cutoffs[(i-1)÷2+1]
            # this prevents a few elements from being written that will never be read
            if i ≠ 2 || params[1] + 1 < cutoffs[1]
                arr1[i, params...] = (GB[i] .+ sum(A[i,:] .* G_in)) / K_i[i]
            end
        end
    end
end

function fock_diagonal_amps(
    A::AbstractMatrix{Complex{Float64}}, 
    B::AbstractVector{Complex{Float64}}, 
    G0::Complex{Float64}, 
    cutoffs::Tuple,
    precision_bits::Int64
    )
    """Returns the PNR probabilities of a mixed state according to algorithm 1 of
    https://doi.org/10.22331/q-2023-08-29-1097
    Args:
        A, B, G0: required input for recurrence relation
        cutoffs: upper bounds for the number of photons in each mode
        precision_bits: number of bits used to represent a single Fock amplitude
    Returns:
        Submatrices of the Fock representation. Each submatrix contains Fock indices of a certain type.
        arr0 --> type: [a,a,b,b,c,c...]
        arr2 --> type: [a+2,a,b,b,c,c...] / [a,a,b+2,b,c,c...] / ...
        arr1010 --> type: [a+1,a,b+1,b,c,c,...] / [a+1,a,b,b,c+1,c,...] / [a,a,b+1,b,c+1,c,...] / ...
        arr1001 --> type: [a+1,a,b,b+1,c,c,...] / [a+1,a,b,b,c,c+1,...] / [a,a,b+1,b,c,c+1,...] / ...
        arr1 --> type: [a+1,a,b,b,c,c...] / [a,a+1,b,b,c,c...] / [a,a,b+1,b,c,c...] / ...
    """
    
    T = GetPrecision.get_dtype(precision_bits)
    SQRT = GetPrecision.SQRT_dict[precision_bits]

    M = length(cutoffs)

    arr0 = zeros(Complex{T}, cutoffs)
    arr0[fill(1,M)...] = G0
    arr2 = zeros(Complex{T}, M, cutoffs...)
    arr1 = zeros(Complex{T}, 2*M, cutoffs...)
    arr1010 = zeros(Complex{T}, M, M - 1, cutoffs...)
    arr1001 = zeros(Complex{T}, M, M - 1, cutoffs...)


    dict_params = CompactFock_HelperFunctions.construct_dict_params(cutoffs)
    for sum_params in 0:sum(cutoffs)-1
        for params in dict_params[sum_params]
            # diagonal pivots: aa,bb,cc,...
            if (cutoffs[1] == 1) || (params[1] < cutoffs[1]) # julia indexing!
                use_diag_pivot!(A, B, M, cutoffs, params, arr0, arr1, T, SQRT)
            end
            # off-diagonal pivots: d=1: (a+1)a,bb,cc,... | d=2: 00,(b+1)b,cc,... | d=3: 00,00,(c+1)c,... | ...
            for d in 1:M
                if all(params[1:d-1] .== 1) && (params[d] < cutoffs[d])  # julia indexing!
                    use_offDiag_pivot!(A, B, M, cutoffs, params, d, arr0, arr2, arr1010, arr1001, arr1, T, SQRT)
                end
            end
        end
    end
    return Complex{Float64}.(arr0), Complex{Float64}.(arr2), Complex{Float64}.(arr1010), Complex{Float64}.(arr1001), Complex{Float64}.(arr1)
end

end # end module

module DiagonalGrad

import ..GetPrecision
import ..CompactFock_HelperFunctions

function calc_dA_dB(i, G_in_dA, G_in_dB, G_in, A, B, K_l, K_i, M, pivot_val, pivot_val_dA, pivot_val_dB)
    """Calculate the derivatives of a single Fock amplitude w.r.t A and B.
    Args:
        i (int): the element of the multidim index that is increased
        G_in, G_in_dA, G_in_dB (array, array, array): all Fock amplitudes from the 'read' group in the recurrence relation and their derivatives w.r.t. A and B
        A, B (array, vector): required input for recurrence relation (given by mrmustard.physics.fock.ABC)
        K_l, K_i (vector, vector): SQRT[pivot], SQRT[pivot + 1]
        M (int): number of modes
        pivot_val, pivot_val_dA, pivot_val_dB (array, array, array): Fock amplitude at the position of the pivot and its derivatives w.r.t. A and B
    """
    dA = pivot_val_dA .* B[i]
    dB = pivot_val_dB .* B[i]
    dB[i] += pivot_val
    for l in 1:2*M
        dA += K_l[l] * A[i, l] * G_in_dA[l,:,:]
        dB += K_l[l] * A[i, l] * G_in_dB[l,:]
        dA[i, l] += G_in[l]
    end
    return dA ./ K_i[i], dB ./ K_i[i]
end
                                
function use_offDiag_pivot_grad!(A, B, M, cutoffs, params, d, arr0, arr2, arr1010, arr1001, arr1,
    arr0_dA, arr2_dA, arr1010_dA, arr1001_dA, arr1_dA, arr0_dB, arr2_dB, arr1010_dB, arr1001_dB, arr1_dB, T, SQRT)
    """Given params=(a,b,c,...), apply the eqs. 16 & 17 (of https://doi.org/10.22331/q-2023-08-29-1097)
    for the pivots [a+1,a,b,b,c,c,...] / [a,a,b+1,b,c,c,...] / [a,a,b,b,c+1,c,...] / ..."""
    
    pivot = CompactFock_HelperFunctions.repeat_twice(params)
    pivot[2 * d - 1] += 1
    K_l = SQRT[pivot] # julia indexing counters extra zero in SQRT
    K_i = SQRT[pivot .+ 1] # julia indexing counters extra zero in SQRT
    G_in = zeros(Complex{T}, 2 * M)
    G_in_dA = zeros(Complex{T}, 2*M, size(A)...)
    G_in_dB = zeros(Complex{T}, 2*M, size(B)...)

    ########## READ ##########
    pivot_val = arr1[2 * d - 1, params...]
    pivot_val_dA = arr1_dA[2 * d - 1, params...,:,:]
    pivot_val_dB = arr1_dB[2 * d - 1, params...,:]

    # Array0
    G_in[2 * d - 1] = arr0[params...]
    G_in_dA[2 * d - 1,:,:] = arr0_dA[params...,:,:]
    G_in_dB[2 * d - 1,:] = arr0_dB[params...,:]

    # read from Array2
    if params[d] > 1
        params_adapted = collect(params)
        params_adapted[d] -= 1
        G_in[2 * d] = arr2[d, params_adapted...]
        G_in_dA[2 * d,:,:] = arr2_dA[d, params_adapted...,:,:]
        G_in_dB[2 * d,:] = arr2_dB[d, params_adapted...,:]
    end

    # read from Array11
    for i in d+1:M # i>d
        if params[i] > 1
            params_adapted = collect(params)
            params_adapted[i] -= 1
            G_in[2 * i - 1] = arr1001[d, i - d, params_adapted...]
            G_in_dA[2 * i - 1,:,:] = arr1001_dA[d, i - d, params_adapted...,:,:]
            G_in_dB[2 * i - 1,:] = arr1001_dB[d, i - d, params_adapted...,:]
            G_in[2 * i] = arr1010[d, i - d, params_adapted...]
            G_in_dA[2 * i,:,:] = arr1010_dA[d, i - d, params_adapted...,:,:]
            G_in_dB[2 * i,:] = arr1010_dB[d, i - d, params_adapted...,:]
        end
    end

    ########## WRITE ##########
    G_in .*= K_l

    # Array0
    params_adapted = collect(params)
    params_adapted[d] += 1
    arr0_dA[params_adapted...,:,:], arr0_dB[params_adapted...,:] = calc_dA_dB(2 * d, G_in_dA, G_in_dB, G_in, A, B, K_l, K_i, M, pivot_val, pivot_val_dA, pivot_val_dB)

    # Array2
    if params[d] + 1 < cutoffs[d]
        arr2_dA[d, params...,:,:], arr2_dB[d, params...,:] = calc_dA_dB(2 * d - 1, G_in_dA, G_in_dB, G_in, A, B, K_l, K_i, M, pivot_val, pivot_val_dA, pivot_val_dB)
    end

    # Array11
    for i in d+1:M # i>d
        if params[i] < cutoffs[i]
            arr1010_dA[d, i - d, params...,:,:], arr1010_dB[d, i - d, params...,:] = calc_dA_dB(2 * i - 1, G_in_dA, G_in_dB, G_in, A, B, K_l, K_i, M, pivot_val, pivot_val_dA, pivot_val_dB)
            arr1001_dA[d, i - d, params...,:,:], arr1001_dB[d, i - d, params...,:] = calc_dA_dB(2 * i, G_in_dA, G_in_dB, G_in, A, B, K_l, K_i, M, pivot_val, pivot_val_dA, pivot_val_dB)
        end
    end
end
function use_diag_pivot_grad!(A, B, M, cutoffs, params, arr0, arr1, arr0_dA, arr1_dA, arr0_dB, arr1_dB, T, SQRT)
    """Given params=(a,b,c,...), apply the eqs. 16 & 17 (of https://doi.org/10.22331/q-2023-08-29-1097)
     for the pivot [a,a,b,b,c,c...]"""
    pivot = CompactFock_HelperFunctions.repeat_twice(params)
    K_l = SQRT[pivot] # julia indexing counters extra zero in SQRT
    K_i = SQRT[pivot .+ 1] # julia indexing counters extra zero in SQRT
    G_in = zeros(Complex{T}, 2*M)
    G_in_dA = zeros(Complex{T}, 2*M, size(A)...)
    G_in_dB = zeros(Complex{T}, 2*M, size(B)...)

    ########## READ ##########
    pivot_val = arr0[params...]
    pivot_val_dA = arr0_dA[params...,:,:]
    pivot_val_dB = arr0_dB[params...,:]

    # Array1
    for i in 1:2*M
        if params[(i-1)÷2+1] > 1
            i_staggered = i+1-2*((i-1) % 2)
            params_adapted = collect(params)
            params_adapted[(i-1)÷2+1] -= 1
            G_in[i] = arr1[i_staggered, params_adapted...]
            G_in_dA[i,:,:] = arr1_dA[i_staggered, params_adapted...,:,:]
            G_in_dB[i,:] = arr1_dB[i_staggered, params_adapted...,:]
        end
    end

    ########## WRITE ##########
    G_in .*= K_l

    # Array1
    for i in 1:2*M
        if params[(i-1)÷2+1] < cutoffs[(i-1)÷2+1]
            # This if statement prevents a few elements from being written that will never be read
            if i ≠ 2 || params[1] + 1 < cutoffs[1]
                arr1_dA[i, params...,:,:], arr1_dB[i, params...,:] = calc_dA_dB(i, G_in_dA, G_in_dB, G_in, A, B, K_l, K_i, M, pivot_val, pivot_val_dA, pivot_val_dB)
            end
        end
    end
end
function fock_diagonal_grad(
    A::AbstractMatrix{Complex{Float64}}, 
    B::AbstractVector{Complex{Float64}},
    arr0::AbstractArray{Complex{Float64}}, 
    arr2::AbstractArray{Complex{Float64}}, 
    arr1010::AbstractArray{Complex{Float64}}, 
    arr1001::AbstractArray{Complex{Float64}}, 
    arr1::AbstractArray{Complex{Float64}},
    precision_bits::Int64
    )
    """Returns the gradients of the PNR probabilities of a mixed state according to algorithm 1 of
    https://doi.org/10.22331/q-2023-08-29-1097
    Args:
        A, B: required input for recurrence relation
        Submatrices of the Fock representation. Each submatrix contains Fock indices of a certain type.
            arr0 --> type: [a,a,b,b,c,c...]
            arr2 --> type: [a+2,a,b,b,c,c...] / [a,a,b+2,b,c,c...] / ...
            arr1010 --> type: [a+1,a,b+1,b,c,c,...] / [a+1,a,b,b,c+1,c,...] / [a,a,b+1,b,c+1,c,...] / ...
            arr1001 --> type: [a+1,a,b,b+1,c,c,...] / [a+1,a,b,b,c,c+1,...] / [a,a,b+1,b,c,c+1,...] / ...
            arr1 --> type: [a+1,a,b,b,c,c...] / [a,a+1,b,b,c,c...] / [a,a,b+1,b,c,c...] / ...
        precision_bits: number of bits used to represent a single Fock amplitude
    Returns:
        arr0_dA, arr0_dB: derivatives of arr0 w.r.t A and B
    """
    
    T = GetPrecision.get_dtype(precision_bits)
    SQRT = GetPrecision.SQRT_dict[precision_bits]

    cutoffs = size(arr0)
    M = length(cutoffs)

    arr0_dA = zeros(Complex{T}, size(arr0)..., size(A)...)
    arr2_dA = zeros(Complex{T}, size(arr2)..., size(A)...)
    arr1010_dA = zeros(Complex{T}, size(arr1010)..., size(A)...)
    arr1001_dA = zeros(Complex{T}, size(arr1001)..., size(A)...)
    arr1_dA = zeros(Complex{T}, size(arr1)..., size(A)...)
    arr0_dB = zeros(Complex{T}, size(arr0)..., size(B)...)
    arr2_dB = zeros(Complex{T}, size(arr2)..., size(B)...)
    arr1010_dB = zeros(Complex{T}, size(arr1010)..., size(B)...)
    arr1001_dB = zeros(Complex{T}, size(arr1001)..., size(B)...)
    arr1_dB = zeros(Complex{T}, size(arr1)..., size(B)...)

    dict_params = CompactFock_HelperFunctions.construct_dict_params(cutoffs)
    for sum_params in 0:sum(cutoffs)-1
        for params in dict_params[sum_params]
            # diagonal pivots: aa,bb,cc,...
            if (cutoffs[1] == 1) || (params[1] < cutoffs[1]) # julia indexing!
                use_diag_pivot_grad!(A, B, M, cutoffs, params, arr0, arr1, arr0_dA, arr1_dA, arr0_dB, arr1_dB, T, SQRT)
            end
            # off-diagonal pivots: d=1: (a+1)a,bb,cc,... | d=2: 00,(b+1)b,cc,... | d=3: 00,00,(c+1)c,... | ...
            for d in 1:M
                if all(params[1:d-1] .== 1) && (params[d] < cutoffs[d])  # julia indexing!
                    use_offDiag_pivot_grad!(A,B,M,cutoffs,params,d,arr0,arr2,arr1010,arr1001,arr1,arr0_dA,arr2_dA,arr1010_dA,arr1001_dA,arr1_dA,arr0_dB,arr2_dB,arr1010_dB,arr1001_dB,arr1_dB, T, SQRT)
                end
            end
        end
    end

    return Complex{Float64}.(arr0_dA), Complex{Float64}.(arr0_dB)
end

end # end module

module Vanilla

import ..GetPrecision

function vanilla(
    A::AbstractMatrix{Complex{Float64}},
    b::AbstractVector{Complex{Float64}},
    c::Complex{Float64},
    shape::AbstractVector{Int64},
    precision_bits::Int64
    )
    """Vanilla Fock-Bargmann strategy. Fills the tensor by iterating over all indices
    in ndindex (i.e. CartesianIndices) order.
    Both the input and output of this function have dtype Complex{Float64},
    but a higher precision (i.e. ``precision_bits``) is used intermediately to postpone the nummerical blowup
    that results from the instable recurrence relation.

    Args:
        A: A matrix of the Fock-Bargmann representation
        b: B vector of the Fock-Bargmann representation
        c: vacuum amplitude
        shape: shape of the output tensor
        precision_bits: the number of bits used to represent a single Fock amplitude

    Returns:
        Array{Complex{Float64}}: Fock representation of the Gaussian tensor with shape ``shape``
    """

    T = GetPrecision.get_dtype(precision_bits)
    SQRT = GetPrecision.SQRT_dict[precision_bits]

    shape = Tuple(shape)

    path = CartesianIndices(shape)

    G = Array{Complex{T}}(undef,shape) # initialize empty array with high precision values
    G[first(path)] = c

    for idx in Iterators.drop(path, 1)
        update_Fock_array!(G, A, b, idx, SQRT)
    end

    return Complex{Float64}.(G) # convert back to lower precision
end

function update_Fock_array!(
    G::AbstractArray,
    A::AbstractMatrix{Complex{Float64}},
    b::AbstractVector{Complex{Float64}},
    idx::CartesianIndex,
    SQRT::AbstractVector
    )
    """Apply the recurrence relation once and update G at a certain index"""

    i, pivot = get_pivot(idx)

    @views temp = b[i] * G[pivot]
    @inbounds for (j, neighbor) in get_neighbors(pivot)
        @views temp += A[i, j] * G[neighbor] * SQRT[pivot[j]]
    end

    G[idx] = temp / SQRT[idx[i]]
end

function get_pivot(idx::CartesianIndex)
    """returns a single idx where the first non-one value of idx has been lowered.
    E.g. (1,1,5,3) -> (1,1,4,3)"""
    @inbounds @simd for i in 1:length(idx)
        if idx[i] > 1
            return i, CartesianIndex(ntuple(j -> j == i ? idx[j] - 1 : idx[j], length(idx)))
        end
    end
    return 1, idx
end

function get_neighbors(idx::CartesianIndex{N}) where {N}
    """Does the same as get_neighbors, but skips over the first "start" iterations"""
    return ((i, CartesianIndex(ntuple(d -> d == i ? idx[d] - 1 : idx[d], Val(N))))
            for i in 1:N if idx[i] > 1)
end

end # end module

module CompactFock_HelperFunctions

function repeat_twice(params)
    """
    Args:
        params: [a,b,c,...]
    Returns:
        [a,a,b,b,c,c,...]
    """
    pivot = Vector{Int64}(undef, 2 * length(params))
    for (i, val) in enumerate(params)
        pivot[2 * i - 1] = val
        pivot[2 * i] = val
    end
    return pivot
end

function construct_dict_params(cutoffs)
    """
    Args:
        cutoffs (tuple): upper bounds for the number of photons in each mode
    Returns:
        Dict: all possible values for (a,b,c,...), grouped in lists according to their sum a+b+c+...
    """
    M = length(cutoffs)
    indices = Dict{Int64, Vector{Tuple}}()
    for sum_params in 0:sum(cutoffs)-1
        indices[sum_params] = Vector{Tuple}()
    end

    for params in CartesianIndices(cutoffs)
        params_tup = Tuple(params)
        push!(indices[sum(params_tup) - M], params_tup)
    end
    return indices
end

end # end module

module GetPrecision

using MultiFloats

# possible dtypes
const dtypes_dict = Dict(128 => Float64, 256 => Float64x2, 384 => Float64x3, 512 => Float64x4)

# pre-calculate SQRT values
const SQRT_dict = Dict(k => [0;sqrt.(dtypes_dict[k].(1:999))] for k in keys(dtypes_dict))

function get_dtype(precision_bits)
    if !(precision_bits in keys(dtypes_dict))
        error("The possible values for precision_bits are ", keys(dtypes))
    end
    return dtypes_dict[precision_bits]
end

end # end module
